// USE_3D_Printer_Heatbed_RGB.ino

// File needs underscore at start of number filename

// NOTE: Temperature may be incorrect reading

// Please note that this code and method may not give a true
// temperature measurement

// I take no reasonability for any inaccuracies or any damage caused.I take no reasonability
// for any inaccuracies or any damage caused.

// Using eBay 2M Wire K Type Thermocouple Temperature Measuring Probe Sensor 2 Pcs
// eBay seller : sellerbible
// This is used because the supplied Thermocouple with the is too phyically big o fit under my Heat Bed

// Sensor eBay Precision MAX6675 Module + K Type Thermocouple Temperature Sensor for Arduino
// eBay Seller :  lakeyx101

// Arduino Nano

//  RGB LED Colours
//  Blue indicates an error with the Thermocouple Temperature Measuring Probe Sensor
//  Less than or equal to 35°C Green. Cool safe
//  More than 35°C Less than or equal to 45°C Yellow. Medium Heat. This is red + some green, not total green
//  More than 45°C Less than or equal to 50°C Red. Solid. Hot Danger do not touch
//  More than 50°C  Less than or equal to 170°C Red. Flashing. Very Hot Danger do not touch
//  More than 170°C  White Quick Flashing  Red + Green + Blue LED : TOO HOT!!!! OVER Temperature ERROR!!!

// I use resistors for the RGB LED as follows :
// 150 Ohm for Red,
// 100 Ohm for Blue and
// 100 Ohm for Green.

/*
  Built partly from: RGB-FADE Version for "Common Cathode" RGB LED
  Some RGB LEDs have the - (Ground) as the common connection.
  Example: The RGB Electronic Brick
  followed by a version of the RGB FADE Sketch
  that sources current to the LED through 220 ohm resistors. I use 150 Ohm for RED, 100 Ohm for Blue and 100 Ohm for Green
  http:arduino-info.wikispaces.com/YourDuinoStarter_RGB-LED-Fade#CC

  and from

  Ref : https:github.com/ryanjmclaughlin/MAX6675-Library/blob/master/examples/read_temp/read_temp.pde

  Single_Temp.ino - Example using the MAX6675 Library.
  Created by Ryan McLaughlin <ryanjmclaughlin@gmail.com>
  This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
  http:creativecommons.org/licenses/by-sa/3.0/

  Help: Henry's Bench
  http://henrysbench.capnfatz.com/henrys-bench/arduino-temperature-measurements/max6675-temp-module-arduino-manual-and-tutorial/

  and

  Help: Bristol Watch
  http://www.bristolwatch.com/ele2/therc.htm

   NOTE :  Yellow = red + some green, not total green

   I use resistors for the RGB LED as follows : 150 Ohm for RED, 100 Ohm for Blue and 100 Ohm for Green
*/


// Use MAX6675 Library for MAX6675 thermistor chip
#include <MAX6675.h>

// Set up I used for Temperature sensor MAX6675,
// this may not actually use the Ic2 or TWI pins on the Arduino Nano
int thermistorCS  = 9;            //    CS pin on MAX6675 to D9 on Arduino Nano
int thermistorSO  = 8;            //    SO pin of MAX6675 to D8 on Arduino Nano
int thermistorSCK = 10;           //    SCK pin of MAX6675 to D10 on Arduino Nano

int units = 1;                    // Units to readout temperature (0 = raw, 1 = ˚C, 2 = ˚F)

float centigrade = 0.0;           // Temperature output variable

// Initialize the MAX6675 Library for MAX6675 thermistor chip
MAX6675 temperature(thermistorCS, thermistorSO, thermistorSCK, units);

/*-----( Declare Constants and Pin Numbers )-----*/
int redPin   =  6;               //   Red LED connected to digital pin PWM D6 on Arduino Nano
int greenPin =  5;               //   Green LED connected to digital pin PWM D5 on Arduino Nano
int bluePin  =  3;                //   Blue LED connected to digital pin PWM D3 on Arduino Nano

//////////////////////////////////////////////////////////////////////////////////////

void setup()   /****** SETUP: RUNS ONCE ******/
{
  Serial.begin(115200);

  pinMode(redPin, OUTPUT);       //   sets Red the digital pin as output
  pinMode(greenPin, OUTPUT);     //   sets Green the digital pin as output
  pinMode(bluePin, OUTPUT);      //   sets Blue the digital pin as output
}  // --(end setup )---

//////////////////////////////////////////////////////////////////////////////////////

void loop()   /****** LOOP: RUNS CONSTANTLY ******/
{
  // Read the temperature from the MAX6675
  centigrade = temperature.read_temp();

  // Testing   centigrade = 30;

  if (centigrade < 0) {
    // If there is an error with the TC, temperature will be < 0

    turnOffRGB();

    Serial.println("Thermometer Probe Problem");

    // noflash Blue
    for (int noFlash = 0; noFlash < 4; noFlash++)
    {
      analogWrite(bluePin, 255);      // sets the Blue LED on
      delay(500);
    }
  }
  else
  {
    // Display Temperature in Centagade

    // Ambient testing aprox: centigrade = centigrade + 22;

    // Allow for inaccurate temperature reading
    centigrade =  centigrade  * 1.16 - 7;

    Serial.print("Temperature = ");
    Serial.print(centigrade);

    Serial.write(176);  // The degrees symbol

    Serial.print(" C ");

    //  Green= Cool safe
    if (centigrade <= 35)
    {
      turnOffRGB();

      Serial.println(" Cool Green");

      //  noflash Green
      for (int noFlash = 0; noFlash < 4; noFlash++)
      {
        analogWrite(greenPin, 255);    // sets the Green LED on
        delay(500);
      }
    }

    // Yellow = Warm Take some care
    // NOTE :  Yellow = red + some green, not total green
    if ((centigrade > 35) && (centigrade <= 45))
    {
      turnOffRGB();

      Serial.println(" Medium Heat Yellow");

      // noflash Yellow. Red and Green mixed NOTE :  Yellow = red + some green, not total green
      for (int noFlash = 0; noFlash < 4; noFlash++)
      {
        // noflash Yellow. Red and Green mixed NOTE :  Yellow = red + some green, not total green
        analogWrite(redPin, 255);      // sets the Red LED on
        analogWrite(greenPin, 65);    // sets the Green LED partly  Yellow = red + some green, not total green
        delay(500);
      }
    }

    // Red = Hot Danger do not touch
    if ((centigrade > 45) && (centigrade <= 50))
    {
      turnOffRGB();

      Serial.println(" Hot!!! Red");

      // noflash Red
      for (int noFlash = 0; noFlash < 4; noFlash++)
      {
        analogWrite(redPin, 255);      // sets the Red LED on
        delay(500);
      }
    }

    // Red Flashing = Very Hot Danger do not touch
    if ((centigrade > 50) && (centigrade <= 170))
    {
      turnOffRGB();

      Serial.println(" Very HOT!! RED Flashing");

      // flash Red
      for (int flash = 0; flash < 4; flash++)
      {
        analogWrite(redPin, 255);    // sets the Red LED on
        delay(50);
        analogWrite(redPin, 0);      // sets the Red LED off
      }

      // More than 170°C  White Quick Flashing : TOO HOT!!!! OVER Temperature ERROR!!!
      // Red + Green + Blue LED
      if (centigrade > 170)
      {
        turnOffRGB();

        Serial.println(" TOO HOT!!!! OVER Temperature ERROR!!!");

        // White Quick Flashing = Red/Green/Blue
        for (int flash = 0; flash < 4; flash++)
        {
          analogWrite(redPin, 255);    // sets the Red LED on
          analogWrite(greenPin, 255);  // sets the Green LED on
          analogWrite(bluePin, 255);   // sets the Blue LED on

          delay(50);

          turnOffRGB();

          delay(50);
        }//for


        
      }// if
   }// if not probe error
  }  // temp OK

  delay(500);

} // --(end main loop )---

//////////////////////////////////////////////////////////////////////////////////////

void turnOffRGB()
{
  analogWrite(redPin, 0);      // sets the Red LED off
  analogWrite(greenPin, 0);    // sets the Green LED off
  analogWrite(bluePin, 0);     // sets the Blue LED off
}


